Wt: Wt::WInteractWidget Class Reference

Wt 4.10.4

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | List of all members
Wt::WInteractWidget Class Reference

An abstract widget that can receive user-interface interaction. More...

`#include <Wt/WInteractWidget.h>`

Inheritance diagram for Wt::WInteractWidget:
[legend]

## Public Member Functions
| WInteractWidget ()
| Create an InteractWidget.
EventSignal< WKeyEvent > & | keyWentDown ()
| Event signal emitted when a keyboard key is pushed down.
EventSignal< WKeyEvent > & | keyPressed ()
| Event signal emitted when a "character" was entered.
EventSignal< WKeyEvent > & | keyWentUp ()
| Event signal emitted when a keyboard key is released.
EventSignal & | enterPressed ()
| Event signal emitted when enter was pressed.
EventSignal & | escapePressed ()
| Event signal emitted when escape was pressed.
EventSignal< WMouseEvent > & | clicked ()
| Event signal emitted when the primary mouse button was clicked on this widget.
EventSignal< WMouseEvent > & | doubleClicked ()
| Event signal emitted when the primary mouse button was double clicked on this widget.
EventSignal< WMouseEvent > & | mouseWentDown ()
| Event signal emitted when a mouse button was pushed down on this widget.
EventSignal< WMouseEvent > & | mouseWentUp ()
| Event signal emitted when a mouse button was released on this widget.
EventSignal< WMouseEvent > & | mouseWentOut ()
| Event signal emitted when the mouse went out of this widget.
EventSignal< WMouseEvent > & | mouseWentOver ()
| Event signal emitted when the mouse entered this widget.
EventSignal< WMouseEvent > & | mouseMoved ()
| Event signal emitted when the mouse moved over this widget.
EventSignal< WMouseEvent > & | mouseDragged ()
| Event signal emitted when the mouse is dragged over this widget.
EventSignal< WMouseEvent > & | mouseWheel ()
| Event signal emitted when the mouse scroll wheel was used.
EventSignal< WTouchEvent > & | touchStarted ()
| Event signal emitted when a finger is placed on the screen.
EventSignal< WTouchEvent > & | touchEnded ()
| Event signal emitted when a finger is removed from the screen.
EventSignal< WTouchEvent > & | touchMoved ()
| Event signal emitted when a finger, which is already placed on the screen, is moved across the screen.
EventSignal< WGestureEvent > & | gestureStarted ()
| Event signal emitted when a gesture is started.
EventSignal< WGestureEvent > & | gestureChanged ()
| Event signal emitted when a gesture is changed.
EventSignal< WGestureEvent > & | gestureEnded ()
| Event signal emitted when a gesture is ended.
void | setDraggable (const std::string &mimeType, WWidget *dragWidget=nullptr, bool isDragWidgetOnly=false, WObject *sourceWidget=nullptr)
| Configure dragging for drag and drop.
void | unsetDraggable ()
| Disable drag & drop for this widget.
void | setMouseOverDelay (int delay)
| Sets a delay for the mouse over event.
int | mouseOverDelay () const
| Returns the mouse over signal delay.
virtual void | setPopup (bool popup) override
| Lets the widget overlay over other sibling widgets.
virtual void | load () override
| Loads content just before the widget is used.
virtual bool | isEnabled () const override
| Returns whether the widget is enabled.
Public Member Functions inherited from Wt::WWebWidget
| WWebWidget ()
| Construct a WebWidget.
virtual std::vector< WWidget * > | children () const override
| Returns child widgets.
Signal & | childrenChanged ()
| Signal emitted when children have been added or removed.
virtual void | setPositionScheme (PositionScheme scheme) override
| Sets the CSS position scheme.
virtual PositionScheme | positionScheme () const override
| Returns the CSS position scheme.
virtual void | setOffsets (const WLength &offset, WFlags< Side > sides=AllSides) override
| Sets CSS offsets for a non-statically positioned widget.
virtual WLength | offset (Side s) const override
| Returns a CSS offset.
virtual void | resize (const WLength &width, const WLength &height) override
| Resizes the widget.
virtual WLength | width () const override
| Returns the width.
virtual WLength | height () const override
| Returns the height.
virtual void | setMinimumSize (const WLength &width, const WLength &height) override
| Sets a minimum size.
virtual WLength | minimumWidth () const override
| Returns the minimum width.
virtual WLength | minimumHeight () const override
| Returns the minimum height.
virtual void | setMaximumSize (const WLength &width, const WLength &height) override
| Sets a maximum size.
virtual WLength | maximumWidth () const override
| Returns the maximum width.
virtual WLength | maximumHeight () const override
| Returns the maximum height.
virtual void | setLineHeight (const WLength &height) override
| Sets the CSS line height for contained text.
virtual WLength | lineHeight () const override
| Returns the CSS line height for contained text.
virtual void | setFloatSide (Side s) override
| Specifies a CSS float side.
virtual Side | floatSide () const override
| Returns the CSS float side.
virtual void | setClearSides (WFlags< Side > sides) override
| Sets the sides that should be cleared of floats.
virtual WFlags< Side > | clearSides () const override
| Returns the sides that should remain empty.
virtual void | setMargin (const WLength &margin, WFlags< Side > sides=AllSides) override
| Sets CSS margins around the widget.
virtual WLength | margin (Side side) const override
| Returns a CSS margin set.
virtual void | setHiddenKeepsGeometry (bool enabled) override
| Sets whether the widget keeps its geometry when hidden.
virtual bool | hiddenKeepsGeometry () const override
| Returns whether the widget keeps its geometry when hidden.
virtual void | setHidden (bool hidden, const WAnimation &animation=WAnimation()) override
| Hides or shows the widget.
virtual bool | isHidden () const override
| Returns whether the widget is set hidden.
virtual bool | isVisible () const override
| Returns whether the widget is visible.
virtual void | setDisabled (bool disabled) override
| Sets whether the widget is disabled.
virtual bool | isDisabled () const override
| Returns whether the widget is set disabled.
virtual bool | isPopup () const override
| Returns whether the widget is overlayed.
virtual void | setInline (bool isInline) override
| Sets whether the widget is displayed inline or as a block.
virtual bool | isInline () const override
| Returns whether the widget is displayed inline or as block.
virtual void | setDecorationStyle (const WCssDecorationStyle &style) override
| Sets a CSS decoration style.
virtual WCssDecorationStyle & | decorationStyle () override
| Returns the decoration style of this widget.
virtual void | setStyleClass (const WString &styleClass) override
| Sets (one or more) CSS style classes.
virtual WString | styleClass () const override
| Returns the CSS style class.
virtual void | addStyleClass (const WString &styleClass, bool force=false) override
| Adds a CSS style class.
virtual void | removeStyleClass (const WString &styleClass, bool force=false) override
| Removes a CSS style class.
virtual bool | hasStyleClass (const WString &styleClass) const override
| Returns whether the widget has a style class.
virtual void | setVerticalAlignment (AlignmentFlag alignment, const WLength &length=WLength()) override
| Sets the vertical alignment.
virtual AlignmentFlag | verticalAlignment () const override
| Returns the vertical alignment.
virtual WLength | verticalAlignmentLength () const override
| Returns the fixed vertical alignment that was set.
virtual void | setToolTip (const WString &text, TextFormat textFormat=TextFormat::Plain) override
| Sets a tooltip.
virtual void | setDeferredToolTip (bool enable, TextFormat textFormat=TextFormat::Plain) override
| Enable deferred tooltip.
virtual WString | toolTip () const override
| Returns the tooltip.
virtual void | refresh () override
| Refresh the widget.
virtual void | setAttributeValue (const std::string &name, const WString &value) override
| Sets an attribute value.
virtual WString | attributeValue (const std::string &name) const override
| Returns an attribute value.
virtual void | setJavaScriptMember (const std::string &name, const std::string &value) override
| Sets a JavaScript member.
virtual std::string | javaScriptMember (const std::string &name) const override
| Returns the value of a JavaScript member.
virtual void | callJavaScriptMember (const std::string &name, const std::string &args) override
| Calls a JavaScript member.
virtual bool | loaded () const override
| Returns whether this widget has been loaded.
virtual void | setId (const std::string &id) override
| Sets the CSS Id.
virtual WWidget * | find (const std::string &name) override
| Finds a descendent widget by name.
virtual WWidget * | findById (const std::string &id) override
| Finds a descendent widget by id.
virtual void | setSelectable (bool selectable) override
| Sets as selectable.
virtual void | doJavaScript (const std::string &javascript) override
| Executes the given JavaScript statements when the widget is rendered or updated.
virtual const std::string | id () const override
| Returns the (unique) identifier for this object.
void | setLoadLaterWhenInvisible (bool)
| Change the way the widget is loaded when invisible.
std::string | htmlTagName () const
| returns the current html tag name
void | setHtmlTagName (const std::string &tag)
| set the custom HTML tag name
virtual void | setCanReceiveFocus (bool enabled) override
| Sets whether the widget can receive focus.
virtual bool | canReceiveFocus () const override
| Returns whether the widget can receive focus.
virtual bool | setFirstFocus () override
| Set focus on the widget's first descendant.
virtual void | setFocus (bool focus) override
| Sets focus.
virtual bool | hasFocus () const override
| Returns whether the widget currently has the focus.
virtual void | setTabIndex (int index) override
| Sets the tab index.
virtual int | tabIndex () const override
| Returns the tab index.
EventSignal & | blurred ()
| Signal emitted when the widget lost focus.
EventSignal & | focussed ()
| Signal emitted when the widget recieved focus.
virtual bool | scrollVisibilityEnabled () const final override
| Returns whether scroll visibility detection is enabled for this widget.
virtual void | setScrollVisibilityEnabled (bool enabled) final override
| Sets whether scroll visibility detection is enabled for this widget.
virtual int | scrollVisibilityMargin () const final override
| Returns the margin around the viewport within which the widget is considered visible.
virtual void | setScrollVisibilityMargin (int margin) final override
| Sets the margin around the viewport within which the widget is considered visible.
virtual Signal< bool > & | scrollVisibilityChanged () final override
| Signal triggered when the scroll visibility of this widget changes.
virtual bool | isScrollVisible () const final override
| Returns whether this widget is currently considered scroll visible.
virtual void | setThemeStyleEnabled (bool enabled) final override
| Sets whether theme styling for a widget is enabled or disabled.
virtual bool | isThemeStyleEnabled () const final override
| Returns whether this widget is currently styled by the chosen theme.
virtual void | setObjectName (const std::string &name) override
| Sets an object name.
void | setFocus ()
| Sets focus.
Public Member Functions inherited from Wt::WWidget
virtual | ~WWidget ()
| Destructor.
WWidget * | parent () const
| Returns the parent widget.
virtual std::unique_ptr< WWidget > | removeWidget (WWidget *widget)
| Removes a child widget.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
std::unique_ptr< WWidget > | removeFromParent ()
| Removes the widget from its parent.
void | setWidth (const WLength &width)
| Sets the width.
void | setHeight (const WLength &height)
| Sets the height.
virtual void | positionAt (const WWidget *widget, Orientation orientation=Orientation::Vertical)
| Positions a widget next to another widget.
virtual void | toggleStyleClass (const WString &styleClass, bool add, bool force=false)
| Toggles a CSS style class.
std::string | jsRef () const
| Returns a JavaScript expression to the corresponding DOM node.
void | setFocus ()
| Sets focus.
virtual void | acceptDrops (const std::string &mimeType, const WString &hoverStyleClass=WString())
| Sets a mime type to be accepted for dropping.
virtual void | stopAcceptDrops (const std::string &mimeType)
| Indicates that a mime type is no longer accepted for dropping.
virtual void | htmlText (std::ostream &out)
| Streams the (X)HTML representation.
bool | isRendered () const
| Returns whether the widget is rendered.
void | hide ()
| Hides the widget.
void | animateHide (const WAnimation &animation)
| Hides the widget using an animation.
void | show ()
| Shows the widget.
void | animateShow (const WAnimation &animation)
| Shows the widget using an animation.
void | enable ()
| Enables the widget.
void | disable ()
| Disable thes widget.
bool | layoutSizeAware () const
| Returns whether the widget is layout size aware.
Public Member Functions inherited from Wt::WObject
void | addChild (std::unique_ptr< WObject > child)
| Add a child WObject whose lifetime is determined by this WObject.
template<typename Child >
Child * | addChild (std::unique_ptr< Child > child)
| Add a child WObject, returning a raw pointer.
std::unique_ptr< WObject > | removeChild (WObject *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
template<typename Child >
std::unique_ptr< Child > | removeChild (Child *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
virtual std::string | objectName () const
| Returns the object name.
void | resetLearnedSlots ()
| Resets learned stateless slot implementations.
template<class T >
void | resetLearnedSlot (void(T::*method)())
| Resets a learned stateless slot implementation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)())
| Declares a slot to be stateless and learn client-side behaviour on first invocation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)(), void(T::*undoMethod)())
| Declares a slot to be stateless and learn client-side behaviour in advance.
void | isNotStateless ()
| Marks the current function as not stateless.
template<class T >
WStatelessSlot * | implementJavaScript (void(T::*method)(), const std::string &jsCode)
| Provides a JavaScript implementation for a method.
Public Member Functions inherited from Wt::Core::observable
| observable () noexcept
| Default constructor.
virtual | ~observable ()
| Destructor.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...)) noexcept
| Protects a method call against object destruction.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...) const) const noexcept
| Protects a const method call against object destruction.
template<typename Function >
auto | bindSafe (const Function &function) noexcept
| Protects a function against object destruction.

## Protected Member Functions
virtual void | propagateSetEnabled (bool enabled) override
| Propagates that a widget was enabled or disabled through children.
Protected Member Functions inherited from Wt::WWebWidget
virtual void | enableAjax () override
| Progresses to an Ajax-enabled widget.
virtual WStatelessSlot * | getStateless (Method method) override
| On-demand stateless slot implementation.
virtual void | render (WFlags< RenderFlag > flags) override
| Renders the widget.
Protected Member Functions inherited from Wt::WWidget
void | setLayoutSizeAware (bool sizeAware)
| Sets the widget to be aware of its size set by a layout manager.
virtual void | layoutSizeChanged (int width, int height)
| Virtual method that indicates a size change.
| WWidget ()
| Creates a widget.
virtual void | dropEvent (WDropEvent dropEvent)
| Handles a drop event.
virtual int | boxPadding (Orientation orientation) const
| Returns the widget's built-in padding.
virtual int | boxBorder (Orientation orientation) const
| Returns the widget's built-in border width.
void | scheduleRender (WFlags< RepaintFlag > flags=None)
| Schedules rerendering of the widget.
Protected Member Functions inherited from Wt::WObject

## Additional Inherited Members
Public Types inherited from Wt::WObject
typedef void(WObject::*) | Method()
| Typedef for a WObject method without arguments.
Static Public Member Functions inherited from Wt::WWebWidget
static std::string | jsStringLiteral (const std::string &v, char delimiter='\'')
| Turn a CharEncoding::UTF8 encoded string into a JavaScript string literal.
Static Public Member Functions inherited from Wt::WWidget
static WString | tr (const char *key)
| Short hand for WString::tr()
Static Public Member Functions inherited from Wt::WObject
Static Public Attributes inherited from Wt::WWidget
Protected Types inherited from Wt::WWebWidget
Protected Types inherited from Wt::WWidget
Static Protected Attributes inherited from Wt::WWidget

## Detailed Description

An abstract widget that can receive user-interface interaction.

This abstract widget provides access to event signals that correspond to user-interface interaction through mouse or keyboard.

When JavaScript is disabled, only the clicked() event will propagate (but without event details information).

### CSS

Styling through CSS is not applicable.

## Member Function Documentation

## ◆ clicked()

EventSignal< WMouseEvent > & Wt::WInteractWidget::clicked | ( |  | ) |

Event signal emitted when the primary mouse button was clicked on this widget.

The event details contains information such as the button, optional keyboard modifiers, and mouse coordinates relative to the widget, the window window, or the document.

For more details, see the MDN documentation.

Note
  When JavaScript is disabled, the event details contain invalid information.

## ◆ doubleClicked()

EventSignal< WMouseEvent > & Wt::WInteractWidget::doubleClicked | ( |  | ) |

Event signal emitted when the primary mouse button was double clicked on this widget.

The event details contains information such as the button, optional keyboard modifiers, and mouse coordinates relative to the widget, the window window, or the document.

For more details, see the MDN documentation.

Note
  When JavaScript is disabled, the signal will never fire.

## ◆ enterPressed()

EventSignal & Wt::WInteractWidget::enterPressed | ( |  | ) |

Event signal emitted when enter was pressed.

This signal is emitted when the Enter or Return key was pressed.

Form widgets (like WLineEdit) will receive key events when focussed. Other widgets will receive key events when they contain (directly or indirectly) a form widget that has focus.

To capture an enter press when no element has focus, see WApplication::globalEnterPressed()

See also
  keyPressed(), Key::Enter

## ◆ escapePressed()

EventSignal & Wt::WInteractWidget::escapePressed | ( |  | ) |

Event signal emitted when escape was pressed.

This signal is emitted when the Escape key was pressed.

Form widgets (like WLineEdit) will receive key events when focussed. Other widgets will receive key events when they contain (directly or indirectly) a form widget that has focus.

To capture an escape press when no element has focus, see WApplication::globalEscapePressed()

See also
  keyPressed(), Key::Escape

## ◆ gestureChanged()

EventSignal< WGestureEvent > & Wt::WInteractWidget::gestureChanged | ( |  | ) |

Event signal emitted when a gesture is changed.

The event details contains information about the scale and the rotation.

Note
  When JavaScript is disabled, the signal will never fire.

## ◆ gestureEnded()

EventSignal< WGestureEvent > & Wt::WInteractWidget::gestureEnded | ( |  | ) |

Event signal emitted when a gesture is ended.

The event details contains information about the scale and the rotation.

Note
  When JavaScript is disabled, the signal will never fire.

## ◆ gestureStarted()

EventSignal< WGestureEvent > & Wt::WInteractWidget::gestureStarted | ( |  | ) |

Event signal emitted when a gesture is started.

The event details contains information about the scale and the rotation.

Note
  When JavaScript is disabled, the signal will never fire.

## ◆ isEnabled()

virtual bool Wt::WInteractWidget::isEnabled | ( |  | ) | const
| overridevirtual

Returns whether the widget is enabled.

A widget is enabled if it is not disabled, and none of its ancestors are disabled. This method returns whether the widget is rendered as enabled, while isDisabled() returns whether a widget has been explicitly disabled.

Note that a widget may be at the same time not enabled, and not disabled, in case one of its ancestors was disabled.

See also
  isDisabled()

Reimplemented from Wt::WWebWidget.

## ◆ keyPressed()

EventSignal< WKeyEvent > & Wt::WInteractWidget::keyPressed | ( |  | ) |

Event signal emitted when a "character" was entered.

The keyPressed signal is emitted when a key is pressed, and a character is entered. Unlike keyWentDown(), it is emitted only for key presses that result in a character being entered, and thus not for modifier keys or keyboard navigation keys.

Form widgets (like WLineEdit) will receive key events when focussed. Other widgets will receive key events when they contain (directly or indirectly) a form widget that has focus.

To capture a key press when no element has focus, see WApplication::globalKeyPressed()

See also
  keyWentDown()

## ◆ keyWentDown()

EventSignal< WKeyEvent > & Wt::WInteractWidget::keyWentDown | ( |  | ) |

Event signal emitted when a keyboard key is pushed down.

The keyWentDown signal is the first signal emitted when a key is pressed (before the keyPressed signal). Unlike keyPressed() however it is also emitted for modifier keys (such as "shift", "control", ...) or keyboard navigation keys that do not have a corresponding character.

Form widgets (like WLineEdit) will receive key events when focussed. Other widgets will receive key events when they contain (directly or indirectly) a form widget that has focus.

To capture a key down event when no element has focus, see WApplication::globalKeyWentDown()

See also
  keyPressed(), keyWentUp()

## ◆ keyWentUp()

EventSignal< WKeyEvent > & Wt::WInteractWidget::keyWentUp | ( |  | ) |

Event signal emitted when a keyboard key is released.

This is the counter-part of the keyWentDown() event. Every key-down has its corresponding key-up.

Form widgets (like WLineEdit) will receive key events when focussed. Other widgets will receive key events when they contain (directly or indirectly) a form widget that has focus.

To capture a key up event when no element has focus, see WApplication::globalKeyWentUp()

See also
  keyWentDown()

## ◆ load()

virtual void Wt::WInteractWidget::load | ( |  | ) |
| overridevirtual

Loads content just before the widget is used.

This function is called when a widget is inserted in the widget hierarchy. Widgets that get inserted in the widget hierarchy will be rendered. Visible widgets are rendered immediately, and invisible widgets in the back-ground (or not for a plain HTML session). This method is called when the widget is directly or indirectly inserted into the widget tree.

The default implementation simply propagates the load signal to its children. You may want to override this method to delay loading of resource-intensive contents.

During the life-time of a widget, this method may be called multiple times, so you should make sure that you do a deferred initialization only once.

Reimplemented from Wt::WWebWidget.

Reimplemented in Wt::WDateEdit, and Wt::WTimeEdit.

## ◆ mouseDragged()

EventSignal< WMouseEvent > & Wt::WInteractWidget::mouseDragged | ( |  | ) |

Event signal emitted when the mouse is dragged over this widget.

The mouse event contains information on the button(s) currently pressed. If multiple buttons are currently pressed, only the button with smallest enum value is returned.

Note
  When JavaScript is disabled, the signal will never fire.

## ◆ mouseMoved()

EventSignal< WMouseEvent > & Wt::WInteractWidget::mouseMoved | ( |  | ) |

Event signal emitted when the mouse moved over this widget.

The mouse event contains information on the button(s) currently pressed. If multiple buttons are currently pressed, only the button with smallest enum value is returned.

Note
  When JavaScript is disabled, the signal will never fire.

## ◆ mouseOverDelay()

int Wt::WInteractWidget::mouseOverDelay | ( |  | ) | const

Returns the mouse over signal delay.

See also
  setMouseOverDelay()

## ◆ mouseWentDown()

EventSignal< WMouseEvent > & Wt::WInteractWidget::mouseWentDown | ( |  | ) |

Event signal emitted when a mouse button was pushed down on this widget.

The event details contains information such as the button, optional keyboard modifiers, and mouse coordinates relative to the widget, the window window, or the document.

Note
  When JavaScript is disabled, the signal will never fire.

## ◆ mouseWentOut()

EventSignal< WMouseEvent > & Wt::WInteractWidget::mouseWentOut | ( |  | ) |

Event signal emitted when the mouse went out of this widget.

Note
  When JavaScript is disabled, the signal will never fire.

## ◆ mouseWentOver()

EventSignal< WMouseEvent > & Wt::WInteractWidget::mouseWentOver | ( |  | ) |

Event signal emitted when the mouse entered this widget.

The signal is emitted as soon as the mouse enters the widget, or after some delay as configured by setMouseOverDelay()

Note
  When JavaScript is disabled, the signal will never fire.

## ◆ mouseWentUp()

EventSignal< WMouseEvent > & Wt::WInteractWidget::mouseWentUp | ( |  | ) |

Event signal emitted when a mouse button was released on this widget.

The event details contains information such as the button, optional keyboard modifiers, and mouse coordinates relative to the widget, the window window, or the document.

If you connect also the mouseWentDown() signal, then a subsequent mouseWentUp() will be received by the same widget, even if mouse is no longer over the original widget.

Note
  When JavaScript is disabled, the signal will never fire.

## ◆ mouseWheel()

EventSignal< WMouseEvent > & Wt::WInteractWidget::mouseWheel | ( |  | ) |

Event signal emitted when the mouse scroll wheel was used.

The event details contains information such as the wheel delta, optional keyboard modifiers, and mouse coordinates relative to the widget, the window window, or the document.

Note
  When JavaScript is disabled, the signal will never fire.

## ◆ propagateSetEnabled()

virtual void Wt::WInteractWidget::propagateSetEnabled | ( | bool | enabled | ) |
| overrideprotectedvirtual

Propagates that a widget was enabled or disabled through children.

When enabling or disabling a widget, you usually also want to disable contained children. This method is called by setDisabled() to propagate its state to all children.

You may want to reimplement this method if they wish to render differently when a widget is disabled. The default implementation will propagate the signal to all children.

Reimplemented from Wt::WWebWidget.

Reimplemented in Wt::WAnchor, Wt::WDateEdit, Wt::WFormWidget, Wt::WLabel, Wt::WPushButton, Wt::WTextEdit, and Wt::WTimeEdit.

## ◆ setDraggable()

void Wt::WInteractWidget::setDraggable | ( | const std::string & | mimeType,
|  | WWidget * | dragWidget = nullptr,
|  | bool | isDragWidgetOnly = false,
|  | WObject * | sourceWidget = nullptr )

Configure dragging for drag and drop.

Enable drag&drop for this widget. The mimeType is used to find a suitable drop target, which must accept dropping of this mimetype.

By default, the entire widget is dragged. One may specify another widget to be dragged (for example the parent as `dragWidget`) or a `dragWidget` whose function is only to represent the drag visually (when `isDragWidgetOnly` = `true`).

The widget to be identified as source in the dropEvent may be given explicitly, and will default to this widget otherwise.

When using a touch interface, the widget can also be dragged after a long press.

Note
  When JavaScript is disabled, drag&drop does not work.

See also
  WWidget::dropEvent(), WWidget::acceptDrops(), WDropEvent

## ◆ setMouseOverDelay()

void Wt::WInteractWidget::setMouseOverDelay | ( | int | delay | ) |

Sets a delay for the mouse over event.

This sets a delay (in milliseconds) before the mouse over event is emitted.

The default value is 0.

See also
  mouseWentOver()

## ◆ setPopup()

virtual void Wt::WInteractWidget::setPopup | ( | bool | popup | ) |
| overridevirtual

Lets the widget overlay over other sibling widgets.

A widget that isPopup() will be rendered on top of any other sibling widget contained within the same parent (including other popup widgets previously added to the container).

This will only have an effect when the widgetis either Wt::PositionScheme::Absolute or Wt::PositionScheme::Fixed positionScheme().

This applies to CSS-based layout, and configures the z-index property.

Reimplemented from Wt::WWebWidget.

## ◆ touchEnded()

EventSignal< WTouchEvent > & Wt::WInteractWidget::touchEnded | ( |  | ) |

Event signal emitted when a finger is removed from the screen.

The event details contains information such as the touches, target touches and changed touches.

Note
  When JavaScript is disabled, the signal will never fire.

## ◆ touchMoved()

EventSignal< WTouchEvent > & Wt::WInteractWidget::touchMoved | ( |  | ) |

Event signal emitted when a finger, which is already placed on the screen, is moved across the screen.

The event details contains information such as the touches, target touches and changed touches.

Note
  When JavaScript is disabled, the signal will never fire.

## ◆ touchStarted()

EventSignal< WTouchEvent > & Wt::WInteractWidget::touchStarted | ( |  | ) |

Event signal emitted when a finger is placed on the screen.

The event details contains information such as the touches, target touches and changed touches.

Note
  When JavaScript is disabled, the signal will never fire.

## ◆ unsetDraggable()

void Wt::WInteractWidget::unsetDraggable | ( |  | ) |

Disable drag & drop for this widget.

See also
  setDraggable()